#This package contains procedures not used in normal mode, such as
# dumping metainformation in text or xml formats.

package provide AlicqInfo 1.0

proc safexml {str} {
	string map [list "<" "&lt;" ">" "&gt;"] $str
}

proc outname {name} { lrange [string map {:: " "} [meta2var $name]] 2 end }

proc showmetainfo {{names {}}} {
	if {![llength $names]} { 
		set names [namespace children ::modules]
	} else { set names [map x $names { set _ ::modules::$x }] }
	foreach ns $names {
		set meta [lsort [metainfo:module $ns]]
		if {![llength $meta]} continue
		puts "Module [namespace tail $ns]"
		set prop [list]
		foreach x $meta {
			if {![array exists $x]} {
				puts [format {%15s: %s} [outname $x] [set $x]]
			} else {lappend prop $x}
		}
		if {[llength $prop]} { puts "     Parameters:"}
		foreach x $prop {
			if {[info exists ${x}(description)]} { 
				set d [set ${x}(description)]
			} else { set d "(no description)" }
			puts [format {%20s - %s} [outname $x] $d]
			foreach field {type default} {
				if {[info exists ${x}($field)]} {
					puts [format {%30s: %s} $field [set ${x}($field)]]
				}
			}
			set value (undefined)
			catch {set value [set [meta2var $x]]} 
			puts [format {%30s: %s} current $value]
		}
		puts ""
	}
	exit
}

proc xmlmetainfo {{names {}}} {
	if {![llength $names]} { 
		set names [namespace children ::modules]
	} else { set names [map x $names { set _ ::modules::$x }] }
	puts "<?xml version=\"1.0\"?>\n<metainformation>"
	foreach ns $names {
		set meta [lsort [metainfo:module $ns]]
		if {![llength $meta]} continue
		puts "\t<module name='[namespace tail $ns]'>"
		set prop [list]
		foreach x $meta {
			set name [outname $x]
			if {![array exists $x]} {
				puts "\t\t<$name>[safexml [set $x]]</$name>"
			} else {
				puts "\t\t<parameter name='$name'>"
				foreach {field val} [array get $x] {
					puts "\t\t\t<$field>[safexml $val]</$field>"
				}
				puts "\t\t</parameter>"
			}
		}
		puts "\t</module>"
	}
	puts "</metainformation>"
	exit
}

