#This is a megawidget providing password authentication dialog capability

package provide AuthDialog 1.0

proc AuthDialog {top args} {
	if {[winfo exists $top]} {
		raise $top
		return
	}
	
	array set opt [list\
		-title "Authorization required"\
		-cancel [list destroy $top]\
		-ok  [list destroy $top]\
		-login Login\
		]

	array set opt $args

	toplevel $top -class Authorization
	wm title $top Authorization
	if {[tk windowingsystem]=="aqua"} {
		::tk::unsupported::MacWindowStyle style $auth movableDBoxProc
	}
	label $top.info -text $opt(-title)
	label $top.lLogin -text $opt(-login) -anchor e
	label $top.lPasswd -text Password -anchor w
	entry $top.login 
	entry $top.password -show *

	grid $top.info -sticky news -columnspan 2 -padx 16 -pady 16
	grid $top.lLogin $top.login -sticky we -padx 4 -pady 4
	grid $top.lPasswd $top.password -sticky we -padx 4 -pady 4
	grid columnconfigure $top 1 -weight 1

	grid [frame $top.btn] -padx 16 -pady 8 -columnspan 2
	grid [button $top.btn.ok -text Ok -default active\
		-command [list _AuthDialogOk $opt(-ok) $top]] x\
	     [button $top.btn.cancel -text Cancel\
		-command [list destroy $top]] -padx 4

	if {[info exists opt(-register)]} {
		grid [button $top.btn.register -text Register\
			-command $opt(-register)] -column 1 -row 0
	}

	bind $top.btn.cancel <Destroy> $opt(-cancel)
	bind $top <Return> [list $top.btn.ok invoke]
	after idle [list focus $top.login]
}

proc _AuthDialogOk {script top} {
	bind $top.btn.cancel <Destroy> ""
	eval $script [$top.login get] [$top.password get]
	destroy $top
}

option add *PasswordDialog.Entry.show *
option add *PasswordDialog.Entry.validate key

proc PasswordDialog {top args} {
	if {[winfo exists $top]} {
		raise $top
		return
	}
	
	array set opt [list\
		-title "New password"\
		-info "New password"\
		-cancel [list destroy $top]\
		-ok  [list destroy $top]\
		]

	array set opt $args

	toplevel $top -class PasswordDialog
	wm title $top $opt(-title)

	if {[tk windowingsystem]=="aqua"} {
		::tk::unsupported::MacWindowStyle style $auth movableDBoxProc
	}

	label $top.info -text $opt(-info)
	label $top.lPassword -text [mc Password] -anchor e
	label $top.lVerify -text [mc Verify] -anchor e
	entry $top.password -vcmd\
		[list _PasswordVerify $top.btn.ok %P $top.verify]
	entry $top.verify -vcmd\
		[list _PasswordVerify $top.btn.ok %P $top.password]

	grid $top.info -sticky news -columnspan 2 -padx 16 -pady 16
	grid $top.lPassword $top.password -sticky we -padx 4 -pady 4
	grid $top.lVerify $top.verify -sticky we -padx 4 -pady 4
	grid columnconfigure $top 1 -weight 1

	grid [frame $top.btn] -padx 16 -pady 8 -columnspan 2
	grid [button $top.btn.ok -text Ok -default active -state disabled\
		-command [list _PasswordDialogOk $opt(-ok) $top]]\
	     [button $top.btn.cancel -text Cancel\
		-command [list destroy $top]] -padx 4
	bind $top.btn.cancel <Destroy> $opt(-cancel)
	bind $top <Return> [list $top.btn.ok invoke]
	after idle [list focus $top.password]
}

proc _PasswordVerify {btn val e} {
	set test [$e get]
	$btn configure -state [expr {($test==$val && $val!="")?"normal":"disabled"}]
	return 1
}

proc _PasswordDialogOk {script top} {
	bind $top.btn.cancel <Destroy> ""
	eval $script [$top.password get]
	destroy $top
}

