
proc ContextMenu {ns context object} {
	Compose $ns ${ns}::objects::meta::* $context $object
	set ns [namespace parent $ns]
	if {$ns!="::"} { ContextMenu $ns $context $object}
}

proc MainMenu {} {
	eval concat [map ns [concat :: [namespace children ::]] { Grep $ns }]
}

proc Grep {ns} {
	grep x [info vars ${ns}::meta::*] {
		[info exists ${x}(type)] && [set ${x}(type)]=="action"
	}
}

proc MenuItem {var {object {}}} {
	upvar #0 $var meta

	if {[info exists meta(group)]} {
		set menu .mnu.m$meta(group)
		if {![winfo exists $menu]} {
			menu $menu
			.mnu add cascade -menu $menu -label [mc $meta(group)]
		}
	} else { set menu .mnu }
	
	set action [namespace tail $var]
	set root [namespace qualifiers [namespace qualifiers $var]]
	if {[info exists meta(script)]} {
		set cmd [list namespace inscope $root $meta(script)]
	} else { set cmd [list Event Global|$action] }
	if {$object!=""} { set cmd [concat $cmd $object] }

	$menu add command -label [mc $action] -command $cmd
}

proc setif {var default} {
	upvar 1 $var n
	if {[info exists n]} { set n } else { set default }
}

proc weight {n1 n2} {
	foreach x {1 2} {
		set w$x [setif [set n${x}](weight) .5]
		set group$x [setif [set n${x}](group) ""]
	}
	set r [expr -[string compare $group1 $group2]]
	if {!$r} { set r [expr {($w1<$w2)?-1:(($w1>$w2)?1:0)}] }
	set r
}

proc MakeMenu {{object ""} {context ""}} {
	if {[winfo exists .mnu]} { destroy .mnu }
	menu .mnu
	if {$object!=""} {
		set ns [namespace qualifiers [namespace qualifiers\
			::[ref $object]]]
		ContextMenu $ns $context $object
	} else { set items [MainMenu] }
	foreach x [lsort -command weight $items] { MenuItem $x $object }
	.mnu post [winfo pointerx .] [winfo pointery .]
}
after idle [nc MakeMenu]
