# This module disables displaying of messages if sender's UIN is not in
# conact list and messages contains 'spam' words.
#
# Author: Ihar Viarheichyk

namespace eval meta {
	set author "Ihar Viarheichyk <iverg@mail.ru>"
	set name "Anti-Spam"
	set description "Block spam messages from UINs not in contact list"
	array set words {
	    type text save change
	    default {sex porn fuck teen hot {\$[0-9]+} XXX hardcore}
	    description "Words or regular\nexpression which can\nindicate spam messages"
	}
	array set reply {
		type text save change
	        default "You are not in my contact list and sent me message which was considered as spam and rejected."
	        description "Reply which is\nsent to sender of\n'spam' message"
	}
}

# Add antispam handler for incoming method to Unknown object
# (contact is not in contact list yet)
include Unknown [namespace current] 0.1

proc incoming {type message args} {
	upvar 1 self self
	variable words
	variable reply
	foreach word $words {
		if {[regexp -nocase $word $message]} {
			# Spam message was detected. Check is it possible to 
			# send message back. We only need *real* send without
			# any overrides. Detecting real send namespace from 
			# object identifier
			set cmd ::tags::[lindex $self 0]::send
			if {[info commands $cmd]==$cmd} {
				catch { $cmd text $reply }
			}
			my log notice "Spam blocked from $self: $message"
			return -code break
		}
	}
}

