# Emoticons module for Alicq IM.
# Author: 

package require resource

namespace eval meta {
	set description "Display emoticons in message dialogs"
	set author "Ihar Viarheichyk <iverg@mail.ru>"

	proc unload {} { resource::unregister emoticons }
}
array set mapping {
	smile { :) :-) }
	wink  { ;) ;-) }
	ironic { :-/ :-\\ }
	tongue  { :-P :P :-p :p }
	grin { :-D :)) :-)) }
	sad  { :-( :( }
}

# Mix in emoticon method implementations for Chat class
include Chat [namespace current] 0.5

# Hide test marked as emoticon
proc initialize {args} { 
	upvar 1 self self
	[$self in] tag configure emoticon -elide yes
}

# Search emoticons in a text range and mark them
proc highlight {from to} {
	upvar 1 self self
	variable mapping
	set txt [$self in]
	foreach {image list} [array get mapping] {
		foreach x $list {
			set i $from
			while {[set i [$txt search -count l $x $i $to]]!={}} {
				$txt tag add emoticon $i "$i + $l char"
				$txt image create $i -image emoticon::$image
				set i [$txt index "$i + $l char"]
			}
		}
	}
}

resource::class emoticons {ui::IconHandler emoticon::} *.gif
resource emoticons [array names mapping]

