# This is alicq module aimed to invoke any executable scripts on some
# Alicq events.

namespace eval meta {
	variable author "Ihar Viarheichyk <iverg@mail.ru>"
	variable description "Invoke any executable scripts on some Alicq events"
}

variable base [file join [file dirname [rcfile]] events]

proc ExtEvent {event args} {
	variable base
	upvar 1 self self
	set l [glob -nocomplain -types {f x} [file join $base $event *]]
	if {[llength $l]} {
		array set ::env [list Alias [$self alias]\
			Groups [$self Groups] Event $event]
		foreach x $l {
			if {[catch {eval [list exec $x $self] $args} reason]} {
				Event Log error "Error invoking $x: $reason"
			}
		}
	}
}

# Mix in status and incoming methods implementations to Contact
namespace eval monitor-contact {
	include Contact [namespace current] 0.8

	interp alias {} [namespace current]::new-status {}\
		[namespace parent]::ExtEvent Status

	interp alias {} [namespace current]::incoming {}\
		[namespace parent]::ExtEvent Incoming
}

# Mix in new-status method to account object
namespace eval monitor-account {
	my include [namespace current] 0.8
	interp alias {} [namespace current]::new-status {}\
		[namespace parent]::ExtEvent MyStatus
}

