namespace eval meta {
	set description "Transliterate cyrillic to/from latin"
	set author "Ihar Viarheichyk <iverg@mail.ru>"
	set capabilities {unloadable}

	proc unload {} { unset [ref Contact]::meta::translit }
}

set forward "\u430 a \u431 b \u432 v \u433 g \u434 d \u437 z \u438 i \u439 j \u43a k \u43b l \u43c m \u43d n \u43e o \u43f p \u440 r \u441 s \u442 t \u443 u \u444 f \u445 h \u44a ' \u44b y \u44c ' \u44d e \u44e ju \u44f ja \u435 je \u451 jo \u436 zh \u446 ts \u447 ch \u448 sh \u449 shch"

set extra "ya \u44f yo \u451 yu \u44e ye \u435"

foreach a $forward { lappend forward [string totitle $a] }
foreach a $extra { lappend extra [string totitle $a] }
set backward [list]
foreach a $forward { set backward [concat $a $backward] }
set backward [concat $extra $backward]

method Translit send {type message} {
	if {$type=="text"} { 
		upvar 1 args args
		variable forward
		set args [list $type [string map $forward $message]]
	}
	return -code continue
}

method Translit incoming {type message args} {
	if {$type=="text"} {
		upvar 1 args Args
		variable backward
		set Args [concat [list $type [string map $backward $message]]\
			$args]
	}
}

# Make all obects with Translit mixin be parents of
# {special Transliterate} group
method Translit parents {} { list {special Transliterate} }

namespace eval Special-Translit {
	tags::new {special Transliterate} [list [namespace current] 0.2\
		Group 0.5]
	# Mix Translit handlers to object methods
	proc add {id} { $id include Translit 0.1 }

	# Remove translit mix
	proc remove {id} { $id exclude Translit }

	# This group is always a member of "Special" group
	proc parents {} { return -code return [list {tree special}] }

	proc accepts {id} { return -code return [$id is Contact] }

	proc hint {} { return -code return "Messages to and from this group members\nare transliterated" }
}

